#include <cstdio>

#include <arc/common.h>
#include <arc/giis.h>

std::list<URL> ConvertToURLs(std::list<std::string>);

std::list<URL> GetGIISList() {

	std::list<std::string> GIISFileLocations;
	std::string giisstrings;

	std::string home = GetEnv("HOME");
	if (home.empty()==false) {
		std::string usergiislist = home + "/.nggiislist";
		GIISFileLocations = ReadFile(usergiislist);
		if (!GIISFileLocations.empty())
			return ConvertToURLs(GIISFileLocations);
	}

	std::string nglocation = GetEnv("NORDUGRID_LOCATION");
	if (nglocation.empty()==false) {
		std::string nggiislist = nglocation + "/etc/giislist";
		GIISFileLocations = ReadFile(nggiislist);
		if (!GIISFileLocations.empty())
			return ConvertToURLs(GIISFileLocations);
	}

	GIISFileLocations = ReadFile("/etc/giislist");
	if (!GIISFileLocations.empty())
		return ConvertToURLs(GIISFileLocations);

	throw GIISError("No GIIS list found in standard locations");
}


std::list<URL> ConvertToURLs(std::list<std::string> GIISList) {

	std::list<URL> urllist;
	std::list<std::string>::iterator it;

	for (it = GIISList.begin(); it != GIISList.end(); it++) {
		urllist.push_back( URL(*it) );
	}

	return urllist;
}
