#include "../std.h"
#include "../misc/log_time.h"
#include "../config/conf.h"
#include "../config/environment.h"

#include "config_vo.h"

int config_vo(AuthUser& user,ConfigSections& sect,string& cmd,string& rest) {
  if(strcmp(sect.SectionMatch(),"vo") != 0) return 1;
  if(cmd.length() == 0) return 1;
  string voname;
  string vofile;
  for(;;) {
    if(cmd == "name") {
      voname=rest;
    } else if(cmd == "file") {
      vofile=rest;
    };
    sect.ReadNext(cmd,rest);
    if(sect.SectionNew() || (cmd.length() == 0)) {
      if(voname.length() && vofile.length()) {
        user.add_vo(voname,vofile);
      };
      if(cmd.length() == 0) return 1;
      if(strcmp(sect.SectionMatch(),"vo") != 0) return 1;
      voname=""; vofile="";
    };
  };
}

int config_vo(list<AuthVO>& vos,ConfigSections& sect,string& cmd,string& rest) {
  if(strcmp(sect.SectionMatch(),"vo") != 0) return 1;
  if(cmd.length() == 0) return 1;
  string voname;
  string vofile;
  for(;;) {
    if(cmd == "name") {
      voname=rest;
    } else if(cmd == "file") {
      vofile=rest;
    };
    sect.ReadNext(cmd,rest);
    if(sect.SectionNew() || (cmd.length() == 0)) {
      if(voname.length() && vofile.length()) {
        vos.push_back(AuthVO(voname,vofile));
      };
      if(cmd.length() == 0) return 1;
      if(strcmp(sect.SectionMatch(),"vo") != 0) return 1;
      voname=""; vofile="";
    };
  };
}

// vo name filename etc.
int config_vo(AuthUser& user,const string& cmd,string& rest) {
  if(cmd != "vo") return 1;
  string voname = config_next_arg(rest);
  string vofile = config_next_arg(rest);
  if((voname.length() == 0) || (vofile.length() == 0)) {
    return -1;
  };
  user.add_vo(voname,vofile);
  return 0;
}

int config_vo(list<AuthVO>& vos,const string& cmd,string& rest) {
  if(cmd != "vo") return 1;
  string voname = config_next_arg(rest);
  string vofile = config_next_arg(rest);
  if((voname.length() == 0) || (vofile.length() == 0)) {
    return -1;
  };
  vos.push_back(AuthVO(voname,vofile));
  return 0;
}

int config_vo(AuthUser& user,const char* cmd,const char* rest) {
  string cmd_(cmd);
  string rest_(rest);
  return config_vo(user,cmd_,rest_);
}

int config_vo(list<AuthVO>& vos,const char* cmd,const char* rest) {
  string cmd_(cmd);
  string rest_(rest);
  return config_vo(vos,cmd_,rest_);
}


