#ifndef __HTTPSD_SRM_CLIENT_H__
#define __HTTPSD_SRM_CLIENT_H__

#include <string>
#include <list>

#include "srm_url.h"

#include "../client/client.h"

class SRMClient;

class SRMRequest {
 friend class SRMClient;
 private:
  int request_id;
  list<int> file_ids;
 public:
  SRMRequest(void):request_id(-1) { };
  ~SRMRequest(void) { };
};

class SRMClient {
 private:
  bool valid;
  struct soap soap;
  HTTP_ClientSOAP* c;
  int timeout;
  bool acquire(SRMRequest& req,list<string>& urls);
 public:
  SRMClient(const char* base_url);
  ~SRMClient(void);
  bool connect(void);
  bool disconnect(void);
  bool getTURLs(SRMRequest& r,const char* name,const SRM_URL& srm_url,
                              list<string>& urls);
  bool putTURLs(SRMRequest& r,const char* name,const SRM_URL& srm_url,
                              list<string>& urls,unsigned long long size = 0);
  bool release(SRMRequest& r,const char* name,const SRM_URL& srm_url);
  bool info(const char* name,const SRM_URL& srm_url,
                               unsigned long long int& size,string& checksum);
  bool remove(const char* name,const SRM_URL& srm_url);
  operator bool(void) { return c; };
  bool operator!(void) { return !c; };
};

#endif // __HTTPSD_SRM_CLIENT_H__
